// OK
// http://forum.arduino.cc/index.php?topic=115869.0
// https://github.com/do9jhb/FM1216duino (Jan Böhmer DO9JHB)

#include "FM1216.h"
#include <LiquidCrystal.h>

//               lcd(Rs, En, Db4, Db5, Db6, Db7)               
     LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  // LCD-Shield

FM1216 tuner;

unsigned long currentTime;
unsigned long loopTime;
const int pin_A = 3;  // pin 3
const int pin_B = 2;  // pin 2
unsigned char encoder_A;
unsigned char encoder_B;
unsigned char encoder_A_prev=0;
unsigned long frq = 864000;
unsigned long frq_old;
float frq_disp;
boolean dec_mode = 0;

////////////////////////////////////////////////////////////
void setup()
{
  pinMode(pin_A, INPUT_PULLUP);
  pinMode(pin_B, INPUT_PULLUP);
  currentTime = millis();
  loopTime = currentTime; 

 lcd.begin(16, 2); 
 pinMode(10,OUTPUT);
 digitalWrite(10, 1);   
    
  tuner.init();
//  tuner.setStereo(false);    // Mono
  tuner.setFreq(frq);        
  Serial.begin(9600);
  Serial.println("Start");

// start display data
 lcd.setCursor(0,0);
 lcd.print("FM1216-ME 864MHz"); 
 lcd.setCursor(0,1);
 lcd.print(" (C)DJ7OO 2016  "); 
 delay(3000); 
}

////////////////////////////////////////////////////////////
void loop()
{  
 rotary_enc();
 lcd.setCursor(1,1);            // move to the begining of the second line  

if(frq!=frq_old)
  { 
  Serial.println(frq);
  tuner.setFreq(frq); 

  // start display data
 lcd.clear();
 lcd.setCursor(0,0);
 lcd.print(" FRQ: "); 
 frq_disp=frq;
 lcd.print(frq_disp/1000,1); 
 lcd.print(" MHz"); 
  }    
   frq_old=frq;   
}

///////////////////////////////////////////////////////////////////
void rotary_enc()
{
currentTime = millis();
  if(currentTime >= (loopTime + 5)){
    encoder_A = digitalRead(pin_A);    
    encoder_B = digitalRead(pin_B);   
    if((!encoder_A) && (encoder_A_prev)){
      if(encoder_B) {
        frq = frq+100;               
        if(frq>865000) {frq=863000;}   
      }   
      else {
        frq = frq-100;               
        if(frq<863000) {frq=865000;} 
      }   
    }   
    encoder_A_prev = encoder_A;     // Store value of A for next time       
    loopTime = currentTime;         // Updates loopTime
    }
  }


